"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var _randomColor = _interopRequireDefault(require("random-color"));

var _assert = _interopRequireDefault(require("assert"));

var _chalk = _interopRequireDefault(require("chalk"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = api => {
  const paths = api.paths,
        config = api.config,
        log = api.log;
  const absTemplatePath = (0, _path.join)(__dirname, '../../../../template/generators');
  return class Generator extends api.Generator {
    constructor(args, options) {
      super(args, options);
      (0, _assert.default)(typeof this.args[0] === 'string', `
${_chalk.default.underline.cyan('name')} should be supplied

Example: 

  umi g page users
        `.trim());

      if (config.routes) {
        log.warn(`You should config the routes in config.routes manunally since ${_chalk.default.red('config.routes')} exists`);
        console.log();
      }
    }

    writing() {
      const path = this.args[0].toString();
      const name = (0, _path.basename)(path);
      this.fs.copyTpl((0, _path.join)(absTemplatePath, 'page.js'), (0, _path.join)(paths.absPagesPath, `${path}.js`), {
        name
      });
      this.fs.copyTpl((0, _path.join)(absTemplatePath, 'page.css'), (0, _path.join)(paths.absPagesPath, `${path}.css`), {
        color: (0, _randomColor.default)().hexString()
      });
    }

  };
};

exports.default = _default;